
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Scalaz（33）－ Free ：算式－Monadic Programming / iVAN</title>

    <meta name="description" content="Scalaz（33）－ Free ：算式－Monadic Programming   在任何模式的编程过程中都无法避免副作用的产生.我们可以用F[A]这种类型模拟FP的运算指令:A是可能产生副作用的运算,F[_]是个代数数据类型ADT(Algebraic Data Type),可以实现函数组合(functional composition),我们可以不用理会A,先用F[_]来组合形成描述功能的抽象程序AST(Abstract Syntax Tree),对A的运算可以分开另一个过程去实现,而且可以有多种的运算实现方式,这样就达到了算式AST(Monadic Programmin">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Scalaz（33）－ Free ：算式－Monadic Programming</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>  在任何模式的编程过程中都无法避免副作用的产生。我们可以用F[A]这种类型模拟FP的运算指令：A是可能产生副作用的运算，F[_]是个代数数据类型ADT(Algebraic Data Type)，可以实现函数组合（functional composition），我们可以不用理会A，先用F[_]来组合形成描述功能的抽象程序AST(Abstract Syntax Tree)，对A的运算可以分开另一个过程去实现，而且可以有多种的运算实现方式，这样就达到了算式AST（Monadic Programming）、算法（Interpretation）的所谓关注分离（separation of concern）目的。在前面的讨论中我们介绍过：我们可以把任何F[A]升格成Monad，而Monad具备最完善的函数组合性能，特别是它支持for-comprehension这种表达方式。我们可以在for-comprehension框架里进行我们熟悉的行令编程（imperative programming），可以使程序意思表达更加显而易见。</p>
<p>下面我们来做一个简单的示范：模拟一个互动智力算数测试（math quiz)：在系统提示下，用户输入第一个数字、再输入第二个数字、再输入操作符号、系统输出算数操作结果。我们可以设计ADT如下：</p>
<pre><code>1 sealed trait Quiz[+Next]
2 case class Question[Next](que: String, n: String =&gt; Next) extends Quiz[Next]
3 case class Answer[Next](ans: String, n: Next) extends Quiz[Next]</code></pre>
<p>Quiz类型可能属于Question或Answer。Question需要读取一个String类型输入，由于实际需要的可能是一个Int或者是Char，在获取输入后还要进行下一步类型转换（map），所以还必须把一个转换函数String=&gt;Next存放入Question结构。Answer则不需要任何输入，所以我们会把()作为Next的值存入Answer结构。</p>
<p>我们可以map over Next类型获取Quiz的Functor实例：</p>
<pre><code>1   implicit object QFunctor extends Functor[Quiz] {
2     def map[A,B](qa: Quiz[A])(f: A =&gt; B): Quiz[B] =
3       qa match {
4          case q: Question[A] =&gt; Question(q.que, q.n andThen f)
5          case Answer(a,n) =&gt; Answer(a,f(n))
6       }
7   }</code></pre>
<p>从case q: Question[A]可以看出来：map over Next实际上是连续运算（andThen）。</p>
<p>我们再来几个操作帮助方法：</p>
<pre><code>1 //操作帮助方法helper methods
 2   def askNumber(q: String) = Question(q, (inputString =&gt; inputString.toInt))  //_.toInt
 3   def askOperator(q: String) = Question(q, (inputString =&gt; inputString.head.toUpper.toChar))
 4   def answer(fnum: Int, snum: Int, opr: Char) = {
 5     def result =
 6       opr match {
 7         case 'A' =&gt; fnum + snum
 8         case 'M' =&gt; fnum * snum
 9         case 'D' =&gt; fnum / snum
10         case 'S' =&gt; fnum - snum
11       }
12     Answer("my answer is: " + result.toString,())
13   }</code></pre>
<p>我们现在可以这样编写AST了：</p>
<pre><code>1 import Quiz._
2 val prg = for {
3  fn &lt;- askNumber("The first number is:")
4  sn &lt;- askNumber("The second number is:")
5  op &lt;- askOperator("The operation is:")
6  _ &lt;- answer(fn,sn,op)
7 } yield()                                         //&gt; prg  : scalaz.Free[Exercises.interact.Quiz,Unit] = Gosub()</code></pre>
<p>但是，askNumber,askOperator及answer这几个操作函数都返回了Quiz类型，而Quiz类型不是Monad，不支持for-comprehension。我们可以用个隐式转换把所有Quiz[A]升格成Free[Quiz,A]：</p>
<pre><code>1   implicit def quizToFree[A](qz: Quiz[A]): Free[Quiz,A] = Free.liftF(qz)</code></pre>
<p>这个示范完整的源代码如下：</p>
<pre><code> 1 sealed trait Quiz[+Next]
 2 object Quiz {
 3 //问题que:String, 等待String 然后转成数字或操作符号
 4   case class Question[Next](que: String, n: String =&gt; Next) extends Quiz[Next]
 5   case class Answer[Next](ans: String, n: Next) extends Quiz[Next]
 6   implicit object QFunctor extends Functor[Quiz] {
 7     def map[A,B](qa: Quiz[A])(f: A =&gt; B): Quiz[B] =
 8       qa match {
 9          case q: Question[A] =&gt; Question(q.que, q.n andThen f)
10          case Answer(a,n) =&gt; Answer(a,f(n))
11       }
12   }
13 //操作帮助方法helper methods
14   def askNumber(q: String) = Question(q, (inputString =&gt; inputString.toInt))  //_.toInt
15   def askOperator(q: String) = Question(q, (inputString =&gt; inputString.head.toUpper.toChar)) //_.head.toUpper.toChar
16   def answer(fnum: Int, snum: Int, opr: Char) = {
17     def result =
18       opr match {
19         case 'A' =&gt; fnum + snum
20         case 'M' =&gt; fnum * snum
21         case 'D' =&gt; fnum / snum
22         case 'S' =&gt; fnum - snum
23       }
24     Answer("my answer is: " + result.toString,())
25   }
26   implicit def quizToFree[A](qz: Quiz[A]): Free[Quiz,A] = Free.liftF(qz)
27 }
28 import Quiz._
29 val prg = for {
30  fn &lt;- askNumber("The first number is:")
31  sn &lt;- askNumber("The second number is:")
32  op &lt;- askOperator("The operation is:")
33  _ &lt;- answer(fn,sn,op)
34 } yield()                                         //&gt; prg  : scalaz.Free[Exercises.interact.Quiz,Unit] = Gosub()</code></pre>
<p>再看看下面的例子。试着猜测程序的作用：</p>
<pre><code> 1 sealed trait Calc[+A]
 2 object Calc {
 3   case class Push(value: Int) extends Calc[Unit]
 4   case class Add() extends Calc[Unit]
 5   case class Mul() extends Calc[Unit]
 6   case class Div() extends Calc[Unit]
 7   case class Sub() extends Calc[Unit]
 8   implicit def calcToFree[A](ca: Calc[A]) = Free.liftFC(ca)
 9 }
10 import Calc._
11 val ast = for {
12   _ &lt;- Push(23)
13   _ &lt;- Push(3)
14   _ &lt;- Add()
15   _ &lt;- Push(5)
16   _ &lt;- Mul()
17 } yield ()                                        //&gt; ast  : scalaz.Free[[x]scalaz.Coyoneda[Exercises.interact.Calc,x],Unit] = Gosub()</code></pre>
<p>从上面的AST表达方式可以估计到这是一个对Int进行加减乘除的计算器，应该是先通过push把操作对象存入一个Stack。然后对Stack内部的数字进行计算操作。具体是如何实现的，在这个阶段无需知道，这应该是Interpreter的工作。这个例子不就真正体现了算式算法的关注分离了的精髓嘛。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-28 20:47:42</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e7%bc%96%e7%a8%8b%e8%af%ad%e8%a8%80/" title="编程语言">编程语言</a>, <a href="https://www.iamivan.net/tag/scala/" title="scala">scala</a>, <a href="https://www.iamivan.net/tag/%e6%b3%9b%e5%87%bd%e7%bc%96%e7%a8%8b/" title="泛函编程">泛函编程</a>, <a href="https://www.iamivan.net/tag/scalaz/" title="Scalaz">Scalaz</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Scalaz（33）－ Free ：算式－Monadic Programming的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvrBn8M.html" rel="bookmark">泛函编程（24）－泛函数据类型－Monad&comma; monadic programming</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				   在上一节我们介绍了Monad.我们知道Monad是一个高度概括的抽象模型.好像创造Monad的目的是为了抽取各种数据类型的共性组件函数汇集成一套组件库从而避免重复编码.这些能对什么是Monad提供一个明确的答案吗?我们先从上节设计的Monad组件库中的一些基本函数来加深一点对Monad的了解: 1 trait Monad[M[_]] extends Functor[M] { 2 def unit[A](a: A): M[A] 3 def flatMap[A,B](ma: M[A])(f:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgVeP3b.html" rel="bookmark">Scalaz（38）－ Free ：Coproduct－Monadic语句组合</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 很多函数式编程爱好者都把FP称为Monadic Programming,意思是用Monad进行编程.我想FP作为一种比较成熟的编程模式,应该有一套比较规范的操作模式吧.因为Free能把任何F[A]升格成Monad,所以Free的算式(AST).算法(Interpreter)关注分离(separation of concern)模式应该可以成为一种规范的FP编程模式.我们在前面的几篇讨论中都涉及了一些AST的设计和运算,但都是一些功能单一,离散的例子.如果希望通过Free获取一个完整可用的程序,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY5RAeM.html" rel="bookmark">Scalaz（22）－ 泛函编程思维： Coerce Monadic Thinking</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 马上进入新的一年2016了,来点轻松点的内容吧.刚好年底这几天抽空重审了一遍,这时才真正认识到让一个老资格OOP程序猿去编写一段FP程序时会发生什么事情:他会用FP语法和数据类型按照OOP的思维编写程序.其结果就是一段尴尬的代码,让人看得不知怎么去形容,更不用提FP程序的精简高雅了.我在前面博文的示范程序正是落入了这个OOP思维陷阱. 我们先把源代码搬过来看看: package Exercises import scalaz._ import Scalaz._ object reader3 {			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMgK1OM.html" rel="bookmark">Scalaz（36）－ Free ：实践－Free In Action - 实用体验</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 在上面几期讨论中我们连续介绍了Free Monad.因为FP是纯函数编程,也既是纯函数的组合集成,要求把纯代码和副作用代码可以分离开来.Free Monad的程序描述(AST)和程序实现(Interpretation)关注分离(separation of concern)模式恰恰能满足FP要求.我们可以用一些代数数据类型(ADT Algebraic Data Type)来模拟功能,再把这些ADT组合起来形成AST(Abstract Syntax Tree).AST既是对程序功能的描述,它的组成			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN79XJp.html" rel="bookmark">Scalaz（37）－ Free ：实践－DB Transaction free style</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 我一直在不断的提示大家:FP就是Monadic Programming,是一种特殊的编程风格.在我们熟悉的数据库编程领域能不能实现FP风格呢?我们先设计一些示范例子来分析一下惯用的数据库编程过程: 1 import scalaz._ 2 import Scalaz._ 3 import scala.language.higherKinds 4 import scala.language.implicitConversions 5 import com.jolbox.bonecp.BoneCP			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn734Kz.html" rel="bookmark">泛函编程（33）－泛函IO：Free Functor - Coyoneda</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 在前几期讨论中我们终于推导出了Free Monad.这是一个Monad工厂,它可以把任何F[A]变成Monad.可惜的是它对F[A]是有所要求的:F必须是个Functor.Free Monad由此被称为由Functor F 产生的Monad.F必须是Functor,这个门槛使我们在使用Free Monad时很不方便.举个前面讨论过的例子: 1 trait Console[A] 2 case object GetLine extends Console[String] 3 case class			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b24qw4p.html" rel="bookmark">Scalaz（25）－ Monad： Monad Transformer-叠加Monad效果</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  中间插播了几篇scalaz数据类型,现在又要回到Monad专题.因为FP的特征就是Monad式编程(Monadic programming),所以必须充分理解认识Monad.熟练掌握Monad运用.曾经看到一段对Monad的描述:&quot;Monadic for-comprehension就是一种嵌入式编程语言,由它的Monad提供它的语法&quot;.但如果每一种Monad的for-comprehension都独立提供一套语法的话,这种编程语言就显得十分单调.功能简单了.那么既然是FP,我们应该可			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bam07wb.html" rel="bookmark">Scalaz（10）－ Monad：就是一种函数式编程模式－a design pattern</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				   Monad typeclass不是一种类型,而是一种程序设计模式(design pattern),是泛函编程中最重要的编程概念,因而很多行内人把FP又称为Monadic Programming.这其中透露的Monad重要性则不言而喻.Scalaz是通过Monad typeclass为数据运算的程序提供了一套规范的编程方式,如常见的for-comprehension.而不同类型的Monad实例则会支持不同的程序运算行为,如:Option Monad在运算中如果遇到None值则会中途退出:St			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My3ZLEz.html" rel="bookmark">Scalaz（35）－ Free ：运算－Trampoline，say NO to StackOverflowError</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 在前面几次讨论中我们介绍了Free是个产生Monad的最基本结构.它的原理是把一段程序(AST)一连串的运算指令(ADT)转化成数据结构存放在内存里,这个过程是个独立的功能描述过程.然后另一个独立运算过程的Interpreter会遍历(traverse)AST结构,读取结构里的运算指令,实际运行指令.这里的重点是把一连串运算结构化(reify)延迟运行,具体实现方式是把Monad的连续运算方法flatMap转化成一串Suspend结构(case class),把运算过程转化成创建(constr			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwO9Ez.html" rel="bookmark" class="title">图片分享网站的前世今生</a>
					<div>
						谈起相册,首先出现在大家脑海里的肯定就是163相册了,这个耳熟能详的英雄曾经压倒了多少对手,如今却如烛火残年的老人一般危危可急. 当前一段时间地位如同youtube一般的全球图片共享网站flickr被 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9GgVz.html" rel="bookmark" class="title">PS调色实例&colon;中性色调的外景婚纱照片</a>
					<div>
						外景图片如果画面的色调构成比较复杂的话,调成中性色是个比较好的选择.因为中性色可以消除大部分的杂色.只保留淡淡的主色调,画面会感觉统一很多.调色的过程也比较简单:先用调色工具把主色调加强一下,然后降低 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNPX7z.html" rel="bookmark" class="title">关于释放session的两篇文章（一）</a>
					<div>
						session If you are using ASP 3.0 (the version of ASP that comes with Windows 2000 / IIS 5) then you  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKom7b.html" rel="bookmark" class="title">web2&period;0产品以及功能简单介绍</a>
					<div>
						什么是web2.0?web2.0包括那些社会化网络产品以及功能简介 Web2.0,是相对Web1.0的新的一类互联网应用的统称.由Web1.0单纯通过网络浏览器浏览html网页模式向内容更丰富.联系性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPr50z.html" rel="bookmark" class="title">如何防电脑辐射</a>
					<div>
						使用电脑时,最好在显示器前配备质量较好的防辐射屏.注意酌情多吃一些胡萝卜.豆芽.西红柿.瘦肉.动物肝等富含维生素A.C和蛋白质的食物,经常喝些绿茶等等. 对于生活紧张而忙碌的人群来说,抵御电脑辐射最简 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNrvqb.html" rel="bookmark" class="title">Photoshop制作彩色艺术光丝壁纸</a>
					<div>
						光束看上去比较简单,制作起来是非常复杂的.尤其是一些弯曲的光束,转折的部分比较难刻画.最好是先分析好光束的构造,然后再分段来制作,这样就容易很多. 最终效果 &lt;点小图查看大图&gt; 1.新建一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8B1vp.html" rel="bookmark" class="title">Photoshop打造金色金属心形彩带</a>
					<div>
						金属彩带由两个大的部分构成:中间金属心形及边缘部分的金属彩带.制作的过程略有不同,心形部分直接用图层样式制作金属质感,其它装饰部分则需要手工渲染质感. 最终效果 &lt;点小图查看大图&gt; 1.p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oExWb.html" rel="bookmark" class="title">小技巧让U盘使用得心应手</a>
					<div>
						  U盘如何才能应用得更得心应手?下面就教大家几招: 一.若系统感染病毒,应先升级杀毒软件病毒库,重新启动并按 F8键,进入安全模式下全面杀毒.杀毒前不要双击任何一个驱动器的盘符,以免病毒再次运行.如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8jn1p.html" rel="bookmark" class="title">嵌入窗口-获得父窗口大小变更的消息</a>
					<div>
						问题描述 获得父窗口大小变更的消息 我在进行UG的二次开发,在它原来的对话框上嵌入了一个MFC窗口,现在的问题是,当主窗口拖动改变大小时,这个MFC窗口大小不会变,我想截取父窗口的拖动消息,不知道怎么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywLZPz.html" rel="bookmark" class="title">零基础学习AJAX之制作自动校验的表单&lowbar;AJAX相关</a>
					<div>
						传统网页在注册时检测用户名是否被占用,传统的校验显然缓慢笨拙. 当ajax出现后,这种体验有了很大的改观,因为在用户填写表单时,签名的表单项已经发送给了服务器,然后根据用户填写好的内容进行数据查询.在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3438z.html" rel="bookmark" class="title">很酷的60款jQuery 幻灯片演示和下载&lowbar;jquery</a>
					<div>
						Cloud Carousel (演示 | 下载) ShineTime (演示 | 下载) Nivo Slider (演示 | 下载) Interactive Photo Desk (演示 | 下载)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPP8xDp.html" rel="bookmark" class="title">android-如何在安卓中显示一组可切换图片</a>
					<div>
						问题描述 如何在安卓中显示一组可切换图片 我最近遇到一个安卓的问题: 当我需要在一个Activity里面显示一组图片,而且: 1. 能用手势切换图片: 2. 图片不能是预先加入资源的那种,因为图片来自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamkGJb.html" rel="bookmark" class="title">数据结构 算法-如何用java中串的操作方法找出两个字符串中所有共同的字符</a>
					<div>
						问题描述 如何用java中串的操作方法找出两个字符串中所有共同的字符 通过实现对串的基本操作的算法设计,运用模式匹配算法KMP和Brute-Force,展出两个字符串中所有共同的字符,判断一个字符串是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lgR3b.html" rel="bookmark" class="title">php-请教PHP的floor函数问题</a>
					<div>
						问题描述 请教PHP的floor函数问题 $money=271.29;echo $money=floor($money*pow(102));这个打印为什么是27129 $money=271.28;ec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rrOap.html" rel="bookmark" class="title">微博原创</a>
					<div>
						@议文:小黑裙在时尚舞台的地位不容撼动,但穿了那么多年的小黑裙难免对它心生厌恶.小红裙倒是不错,但考虑到中国国情,红裙太过招摇,尤其在婚礼等场合不宜穿着,以免得罪新娘.小蓝裙在这个时候的地位就凸显出来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKEAqb.html" rel="bookmark" class="title">c&num; winform 怎么实现下载网络url</a>
					<div>
						问题描述 c# winform 怎么实现下载网络url 在winform程序里面,怎么把比如http://www.xxxx.com/upload/xxx.asp?x=0&amp;y=0 这样的下载下来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkkZZM.html" rel="bookmark" class="title">微信公众开发能跳转到其他应用的页面吗？？？</a>
					<div>
						问题描述 微信公众开发能跳转到其他应用的页面吗??? 开发微信服务号的时候,能不能实现我点击某个自定义菜单的时候,会跳转到其他应用,比如说,安卓市场的主界面??? 解决方案 不好意思,我记错了,刚查了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjWPZM.html" rel="bookmark" class="title">台积电传痛宰三星，吃高通骁龙订单</a>
					<div>
						台积电痛宰三星电子,抢下高通(Qualcomm)骁龙(Snapdragon)处理器大单?据传台积电微缩制程进度大幅超前三星,高通变心,决定把 7 纳米芯片订单转给台积电. 韩国媒体 etnews 报导 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Yen4z.html" rel="bookmark" class="title">盘石网盟龙盘4&period;0账户报告带来详细分析</a>
					<div>
						广告主在投放了广告之后,都希望能够清楚地看到自己每天的消费情况,知道自己的钱被用在了哪些地方,实现了怎样的效果,盘石网盟广告为了让各位广告主们心里都有个数,专门设置了数据报表的功能.通过表格的形式,清 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Y4nxz.html" rel="bookmark" class="title">我国多个地区成品油价下跌需求疲软系主因</a>
					<div>
						需求不足 重庆汽油批发价暴跌500元/吨 外地便宜油来渝抢市场加剧价格战 重庆地区降价幅度全国最大 成品油上调仅过4天,我市成品油批发价这两天却出现罕见的暴跌:柴油下跌100多元/吨,汽油价最多降了5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmgPLp.html" rel="bookmark" class="title">Android签名知识小结&lowbar;Android</a>
					<div>
						一.为什么要签名 开发Android的人这么多,完全有可能大家都把类名,包名起成了一个同样的名字,这时候如何区分?签名这时候就是起区分作用的. 由于开发商可能通过使用相同的Package Name来混 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0vv1z.html" rel="bookmark" class="title">java webApp异步上传图片实现代码&lowbar;java</a>
					<div>
						如何实现java webApp异步上传图片,先了解以下几个问题: 1.图片上传: 2.图片上传预览: 3.上传图片更改地址异步添加到数据库: 主要内容 本示例主要采用纯HTML前端和JavaScrip ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnYOqp.html" rel="bookmark" class="title">asp&period;net字符串处理类代码&lowbar;实用技巧</a>
					<div>
						复制代码 代码如下: using System; using System.Collections; using System.Collections.Generic; using System.Te ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6Gv8Ap.html" rel="bookmark" class="title">java遍历读取xml文件内容&lowbar;java</a>
					<div>
						本文实例讲解了java遍历读取xml文件内容的详细代码,分享给大家供大家参考,具体内容如下 package test; import java.io.FileInputStream; import j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLX6EM.html" rel="bookmark" class="title">《嵌入式C编程：PIC单片机和C编程技术与应用》一2&period;5　设计文档</a>
					<div>
						本节书摘来自华章出版社&lt;嵌入式C编程:PIC单片机和C编程技术与应用&gt;一书中的第2章,第2.5节,作者 ［美］马克·西格斯蒙德(Mark Siegesmund),更多章节内容可以访问&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44ll1z.html" rel="bookmark" class="title">css样式表的问题</a>
					<div>
						问题描述 我想替换样式表,例如我有一个div是这样的&lt;div id=&quot;myid&quot; class=&quot;myclass&quot;&gt;&lt;/div&gt;然后样式表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQW3o8p.html" rel="bookmark" class="title">同工不同酬 报告显示美科技公司存在种族歧视</a>
					<div>
						网易科技讯 10月10日消息,据今日美国报道,种族多样性是近来各大科技公司非常重视的一个问题,不少公司都致力于让少数族裔获得更多进入科技公司的机会.但最新出炉的一些http://www.aliyun. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenPrNb.html" rel="bookmark" class="title">&lbrack;实践&rsqb; Android5&period;1&period;1源码 - 让某个APP以解释执行模式运行</a>
					<div>
						前言 本文的实践修改了Android5.1.1的源码. 本文只简单的讲了一下原理.在&quot;实践&quot;一节讲了具体做法. 本文的内容涉及Art模式下dex加载的知识,想要详细了解这部分知识可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWdmRAp.html" rel="bookmark" class="title">微软详细说明了用户在Word和Outlook中的前10个语法错误</a>
					<div>
						当用户在微软Word中打字,或在Outlook中写电子邮件时,毫无疑问他们会有时候会面临一些语法和拼写错误.现在,微软公布了了Outlook和Word中的前10大语法错误. 这份统计数据基于数百万订阅 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zengXOb.html" rel="bookmark" class="title">Twitter变卖打击员工士气，许多人已干脆不去上班</a>
					<div>
						微博客的鼻祖Twitter,已经到了最危险的时候.之前媒体报道谷歌.苹果等大型科技公司都没有兴趣收购Twitter,Twitter股价暴跌.而据&lt;纽约时报&gt;最新报道,提供在线软件服务的Sa ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
